#include <stdlib.h>
#include <assert.h>
#include <stdbool.h>
#include "ListeChaineeDeCaracteres.h"

LCDC_ListeChainee LCDC_listeChainee(){
  errno=0;
  return NULL;
}

int LCDC_estVide(LCDC_ListeChainee l) {
  errno=0;
  return (l==NULL);
}

void LCDC_ajouter(LCDC_ListeChainee* pl, char e) {
  LCDC_ListeChainee pNoeud=(LCDC_ListeChainee)malloc(sizeof(LCDC_Noeud));
  if (pNoeud!=NULL) {
      errno=0;
      pNoeud->lElement=e;
      pNoeud->listeSuivante=*pl;
      *pl=pNoeud;
  } else {
    errno=LCDC_ERREUR_MEMOIRE;
  }
}

char  LCDC_obtenirElement(LCDC_ListeChainee l) {
  assert(!LCDC_estVide(l));
  errno=0;
  return l->lElement;
}

LCDC_ListeChainee LCDC_obtenirListeSuivante(LCDC_ListeChainee l) {
  assert(!LCDC_estVide(l));
  errno=0;
  return l->listeSuivante;
}

void LCDC_fixerElement(LCDC_ListeChainee* pl, char e) {
  assert(!LCDC_estVide(*pl));
  errno=0;
  (*pl)->lElement=e;
}

void LCDC_fixerListeSuivante(LCDC_ListeChainee* pl, LCDC_ListeChainee suivant) {
  assert(!LCDC_estVide(*pl));
  errno=0;
  (*pl)->listeSuivante=suivant;
}

void LCDC_supprimerTete(LCDC_ListeChainee* pl){
  LCDC_ListeChainee temp;
  assert(!LCDC_estVide(*pl));
  errno=0;
  temp=*pl;
  *pl=LCDC_obtenirListeSuivante(*pl);
  free(temp);
}

void LCDC_supprimer(LCDC_ListeChainee* pl){
  errno=0;
  if (!LCDC_estVide(*pl)) {
    LCDC_supprimerTete(pl);
    LCDC_supprimer(pl);
  } 
}

LCDC_ListeChainee LCDC_copier(LCDC_ListeChainee l) {
  LCDC_ListeChainee temp;
  errno=0;
  if (LCDC_estVide(l))
    return LCDC_listeChainee();
  else {
    temp=LCDC_copier(LCDC_obtenirListeSuivante(l));
    LCDC_ajouter(&temp,LCDC_obtenirElement(l));
    return temp;
  }
}

int LCDC_egale(LCDC_ListeChainee l1,LCDC_ListeChainee l2) {
  errno=0;
  if (LCDC_estVide(l1) && LCDC_estVide(l2))
    return true;
  else {
    if (LCDC_estVide(l1) || LCDC_estVide(l2))
      return false;
    else {
      if (LCDC_obtenirElement(l1)==LCDC_obtenirElement(l2))
	return LCDC_egale(LCDC_obtenirListeSuivante(l1),LCDC_obtenirListeSuivante(l2));
      else
	return false;
    }
  }
}


